Tasks
This module covers task-related operations within Zoho Projects. Use this API to create, copy, move, delete, or get task details, manage baselines, set dependencies, and retrieve status or layout-specific work hour details.
This module covers task-related operations within Zoho Projects. Use this API to create, copy, move, delete, or get task details, manage baselines, set dependencies, and retrieve status or layout-specific work hour details.
Retrieve all tasks across the Zoho Projects portal. Use this API to fetch tasks from all projects within a portal.
OAuth Scope:
ZohoProjects.tasks.READ
String
requiredUnique, immutable identifier of the portal in Zoho Projects. You can obtain it from the Get Portals API (the "id" field in the response).
int
default : 1Enter the page number to retrieve.
int
limit : 1-200Enter the number of entries to display per page.
JSONObject
Specify the filter criteria to apply to the task list.
String
Enter the sort criteria. Accepted values: ASC(field_name) or DESC(field_name). Fields you can sort by include id, name, start_date, end_date, completion_percentage, created_time, last_modified_time, created_by and is_completed.
String
Enter the custom view ID.
String
regex : ISO-8601Enter the start date of the task
Request Example
curl -X GET \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22field_name%22%3A%22name%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%22Design%22%5D%2C%22module_name%22%3A%22bug%22%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021&last_modified_time=1631538698839' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks";
filter_value = {"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"};
params = Map();
params.put("page", 1);
params.put("per_page", 10);
params.put("filter", filter_value);
params.put("sort_by", "ASC(last_modified_time)");
params.put("view_id", "23806000074760021");
params.put("last_modified_time", "1631538698839");
response = invokeUrl
[
url: url
type: GET
parameters: params
connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks');
url.searchParams.append('page', '1');
url.searchParams.append('per_page', '10');
url.searchParams.append('filter', '{"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"}');
url.searchParams.append('sort_by', 'ASC(last_modified_time)');
url.searchParams.append('view_id', '23806000074760021');
url.searchParams.append('last_modified_time', '1631538698839');
const options = {
hostname: url.hostname,
path: url.pathname + url.search,
method: 'GET',
headers: {
'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
}
};
const req = https.request(options, (res) => {
let data = '';
res.on('data', (chunk) => { data += chunk; });
res.on('end', () => { console.log(JSON.parse(data)); });
});
req.on('error', (err) => { console.error(err); });
req.end();
require 'net/http'
require 'uri'
require 'json'
url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks")
params = {
"page" => "1",
"per_page" => "10",
"filter" => "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}",
"sort_by" => "ASC(last_modified_time)",
"view_id" => "23806000074760021",
"last_modified_time" => "1631538698839"
}
url.query = URI.encode_www_form(params)
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
response = http.request(request)
puts response.read_body
<?php
$params = [
'page' => '1',
'per_page' => '10',
'filter' => '{"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"}',
'sort_by' => 'ASC(last_modified_time)',
'view_id' => '23806000074760021',
'last_modified_time' => '1631538698839',
];
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks" . "?" . http_build_query($params);
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => $url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_HTTPHEADER => [
"Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
],
]);
$response = curl_exec($curl);
curl_close($curl);
echo $response;
import requests
url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks"
params = {
"page": "1",
"per_page": "10",
"filter": "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}",
"sort_by": "ASC(last_modified_time)",
"view_id": "23806000074760021",
"last_modified_time": "1631538698839"
}
headers = {
"Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
}
response = requests.get(url, headers=headers, params=params)
print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
int main(void) {
CURL *curl = curl_easy_init();
if (curl) {
char *enc_page = curl_easy_escape(curl, "1", 0);
char *enc_per_page = curl_easy_escape(curl, "10", 0);
char *enc_filter = curl_easy_escape(curl, "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}", 0);
char *enc_sort_by = curl_easy_escape(curl, "ASC(last_modified_time)", 0);
char *enc_view_id = curl_easy_escape(curl, "23806000074760021", 0);
char *enc_last_modified_time = curl_easy_escape(curl, "1631538698839", 0);
char url[2048];
snprintf(url, sizeof(url), "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks?page=%s&per_page=%s&filter=%s&sort_by=%s&view_id=%s&last_modified_time=%s", enc_page, enc_per_page, enc_filter, enc_sort_by, enc_view_id, enc_last_modified_time);
struct curl_slist *headers = NULL;
headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
curl_easy_setopt(curl, CURLOPT_URL, url);
curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
CURLcode res = curl_easy_perform(curl);
if (res != CURLE_OK)
fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));
curl_free(enc_page);
curl_free(enc_per_page);
curl_free(enc_filter);
curl_free(enc_sort_by);
curl_free(enc_view_id);
curl_free(enc_last_modified_time);
curl_slist_free_all(headers);
curl_easy_cleanup(curl);
}
return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;
var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
var query = HttpUtility.ParseQueryString(string.Empty);
query["page"] = "1";
query["per_page"] = "10";
query["filter"] = "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}";
query["sort_by"] = "ASC(last_modified_time)";
query["view_id"] = "23806000074760021";
query["last_modified_time"] = "1631538698839";
var uriBuilder = new UriBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks") { Query = query.ToString() };
var request = new HttpRequestMessage(HttpMethod.Get, uriBuilder.Uri);
var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>
static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
output->append((char*)contents, size * nmemb);
return size * nmemb;
}
int main() {
CURL* curl = curl_easy_init();
if (curl) {
std::string response;
char* enc_page = curl_easy_escape(curl, "1", 0);
char* enc_per_page = curl_easy_escape(curl, "10", 0);
char* enc_filter = curl_easy_escape(curl, "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}", 0);
char* enc_sort_by = curl_easy_escape(curl, "ASC(last_modified_time)", 0);
char* enc_view_id = curl_easy_escape(curl, "23806000074760021", 0);
char* enc_last_modified_time = curl_easy_escape(curl, "1631538698839", 0);
std::string url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks";
url += "?page=" + std::string(enc_page);
url += "&per_page=" + std::string(enc_per_page);
url += "&filter=" + std::string(enc_filter);
url += "&sort_by=" + std::string(enc_sort_by);
url += "&view_id=" + std::string(enc_view_id);
url += "&last_modified_time=" + std::string(enc_last_modified_time);
struct curl_slist* headers = NULL;
headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);
CURLcode res = curl_easy_perform(curl);
if (res == CURLE_OK)
std::cout << response << std::endl;
else
std::cerr << curl_easy_strerror(res) << std::endl;
curl_free(enc_page);
curl_free(enc_per_page);
curl_free(enc_filter);
curl_free(enc_sort_by);
curl_free(enc_view_id);
curl_free(enc_last_modified_time);
curl_slist_free_all(headers);
curl_easy_cleanup(curl);
}
return 0;
}
(require '[clj-http.client :as client])
(let [enc-page (java.net.URLEncoder/encode "1" "UTF-8")
enc-per_page (java.net.URLEncoder/encode "10" "UTF-8")
enc-filter (java.net.URLEncoder/encode "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}" "UTF-8")
enc-sort_by (java.net.URLEncoder/encode "ASC(last_modified_time)" "UTF-8")
enc-view_id (java.net.URLEncoder/encode "23806000074760021" "UTF-8")
enc-last_modified_time (java.net.URLEncoder/encode "1631538698839" "UTF-8")
url (str "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks" "?page=" enc-page "&per_page=" enc-per_page "&filter=" enc-filter "&sort_by=" enc-sort_by "&view_id=" enc-view_id "&last_modified_time=" enc-last_modified_time)]
(def response
(client/get url
{:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"}
:as :json}))
(println (:body response))
package main
import (
"fmt"
"io"
"net/http"
"net/url"
)
func main() {
req, _ := http.NewRequest("GET", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks", nil)
q := req.URL.Query()
q.Add("page", "1")
q.Add("per_page", "10")
q.Add("filter", "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}")
q.Add("sort_by", "ASC(last_modified_time)")
q.Add("view_id", "23806000074760021")
q.Add("last_modified_time", "1631538698839")
req.URL.RawQuery = q.Encode()
req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
resp, _ := http.DefaultClient.Do(req)
defer resp.Body.Close()
body, _ := io.ReadAll(resp.Body)
fmt.Println(string(body))
}
GET https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22field_name%22%3A%22name%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%22Design%22%5D%2C%22module_name%22%3A%22bug%22%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021&last_modified_time=1631538698839 HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22field_name%22%3A%22name%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%22Design%22%5D%2C%22module_name%22%3A%22bug%22%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021&last_modified_time=1631538698839
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();
SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();
URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks");
uriBuilder.addParameter("page", "1");
uriBuilder.addParameter("per_page", "10");
uriBuilder.addParameter("filter", "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}");
uriBuilder.addParameter("sort_by", "ASC(last_modified_time)");
uriBuilder.addParameter("view_id", "23806000074760021");
uriBuilder.addParameter("last_modified_time", "1631538698839");
HttpUriRequest requestObj = new HttpGet(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
HttpResponse response = httpclient.execute(requestObj);
HttpEntity responseEntity = response.getEntity();
Object responseObject = EntityUtils.toString(responseEntity);
String responseString = responseObject.toString();
const url = 'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks';
const params = new URLSearchParams({
'page': '1',
'per_page': '10',
'filter': '{"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"}',
'sort_by': 'ASC(last_modified_time)',
'view_id': '23806000074760021',
'last_modified_time': '1631538698839'
});
const options = {
method: 'GET',
headers: {
'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
}
};
fetch(url + '?' + params.toString(), options)
.then(response => response.json())
.then(data => console.log(data))
.catch(error => console.error(error));
page = 1
per_page = 10
filter = {"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"}
sort_by = "ASC(last_modified_time)"
view_id = "23806000074760021"
last_modified_time = "1631538698839"import java.net.HttpURLConnection
import java.net.URL
import okhttp3.HttpUrl.Companion.toHttpUrl
fun main() {
val urlBuilder = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks".toHttpUrl().newBuilder()
urlBuilder.addQueryParameter("page", "1")
urlBuilder.addQueryParameter("per_page", "10")
urlBuilder.addQueryParameter("filter", "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}")
urlBuilder.addQueryParameter("sort_by", "ASC(last_modified_time)")
urlBuilder.addQueryParameter("view_id", "23806000074760021")
urlBuilder.addQueryParameter("last_modified_time", "1631538698839")
val url = URL(urlBuilder.build().toString())
val conn = url.openConnection() as HttpURLConnection
conn.requestMethod = "GET"
conn.setRequestProperty("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
val response = conn.inputStream.bufferedReader().readText()
println(response)
}
NSString *encodedPage = [@"1" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedPer_page = [@"10" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedFilter = [@"{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedSort_by = [@"ASC(last_modified_time)" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedView_id = [@"23806000074760021" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedLast_modified_time = [@"1631538698839" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *urlString = [NSString stringWithFormat:@"https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks?page=%@&per_page=%@&filter=%@&sort_by=%@&view_id=%@&last_modified_time=%@", encodedPage, encodedPer_page, encodedFilter, encodedSort_by, encodedView_id, encodedLast_modified_time];
NSURL *url = [NSURL URLWithString:urlString];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
[request setHTTPMethod:@"GET"];
[request setValue:@"Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa" forHTTPHeaderField:@"Authorization"];
NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *task = [session dataTaskWithRequest:request
completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
NSString *result = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
NSLog(@"%@", result);
}];
[task resume];
open Lwt
open Cohttp_lwt_unix
let () =
let enc_page = Uri.pct_encode "1" in
let enc_per_page = Uri.pct_encode "10" in
let enc_filter = Uri.pct_encode "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}" in
let enc_sort_by = Uri.pct_encode "ASC(last_modified_time)" in
let enc_view_id = Uri.pct_encode "23806000074760021" in
let enc_last_modified_time = Uri.pct_encode "1631538698839" in
let uri = Uri.of_string ("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks" ^ "?page=" ^ enc_page ^ "&per_page=" ^ enc_per_page ^ "&filter=" ^ enc_filter ^ "&sort_by=" ^ enc_sort_by ^ "&view_id=" ^ enc_view_id ^ "&last_modified_time=" ^ enc_last_modified_time) in
let headers = Cohttp.Header.init ()
|> fun h -> Cohttp.Header.add h "Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
in
Lwt_main.run (
Client.get ~headers uri >>= fun (_, body) ->
Cohttp_lwt.Body.to_string body >|= fun s ->
print_endline s)
$headers = @{
"Authorization" = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
}
$params = @{
page = "1"
per_page = "10"
filter = "{`"criteria`":[{`"field_name`":`"name`",`"criteria_condition`":`"contains`",`"value`":[`"Design`"],`"module_name`":`"bug`"}],`"pattern`":`"1`"}"
sort_by = "ASC(last_modified_time)"
view_id = "23806000074760021"
last_modified_time = "1631538698839"
}
$queryString = ($params.GetEnumerator() | ForEach-Object { "$($_.Key)=$([System.Uri]::EscapeDataString($_.Value))" }) -join "&"
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks" + "?" + $queryString
$response = Invoke-RestMethod -Uri $url -Method GET -Headers $headers
$response | ConvertTo-Json
library(httr)
url <- "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks"
params <- list(
page = "1",
per_page = "10",
filter = "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}",
sort_by = "ASC(last_modified_time)",
view_id = "23806000074760021",
last_modified_time = "1631538698839"
)
response <- GET(
url,
add_headers(Authorization = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"),
query = params
)
content(response, "text")
import Foundation
var components = URLComponents(string: "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/tasks")!
components.queryItems = [
URLQueryItem(name: "page", value: "1"),
URLQueryItem(name: "per_page", value: "10"),
URLQueryItem(name: "filter", value: "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}"),
URLQueryItem(name: "sort_by", value: "ASC(last_modified_time)"),
URLQueryItem(name: "view_id", value: "23806000074760021"),
URLQueryItem(name: "last_modified_time", value: "1631538698839")
]
let url = components.url!
var request = URLRequest(url: url)
request.httpMethod = "GET"
request.setValue("Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa", forHTTPHeaderField: "Authorization")
let semaphore = DispatchSemaphore(value: 0)
let task = URLSession.shared.dataTask(with: request) { data, response, error in
if let data = data, let result = String(data: data, encoding: .utf8) {
print(result)
}
semaphore.signal()
}
task.resume()
semaphore.wait()
Sample Input
Sample Response
Possible Errors
Retrieve all tasks from a specific project. Use this API to list tasks within a project.
OAuth Scope:
ZohoProjects.tasks.READ
String
requiredUnique, immutable identifier of the portal in Zoho Projects. You can obtain it from the Get Portals API (the "id" field in the response).
String
requiredUnique, immutable identifier of the project within the specified portal. You can obtain it from the Get Projects API (the "id" field in the response).
int
default : 1Enter the page number to retrieve.
int
limit : 1-200Enter the number of entries to display per page.
JSONObject
Specify the filter criteria to apply to the task list.
String
Enter the sort criteria. Accepted values: ASC(field_name) or DESC(field_name). Fields you can sort by include id, name, start_date, end_date, completion_percentage, created_time, last_modified_time, created_by and is_completed.
String
Enter the custom view ID. You can obtain it from the Get Task Custom Views API (the "id" field in the response).
String
regex : ISO-8601Enter the start date of the task
Request Example
curl -X GET \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22field_name%22%3A%22name%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%22Design%22%5D%2C%22module_name%22%3A%22bug%22%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021&last_modified_time=1631538698839' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks";
filter_value = {"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"};
params = Map();
params.put("page", 1);
params.put("per_page", 10);
params.put("filter", filter_value);
params.put("sort_by", "ASC(last_modified_time)");
params.put("view_id", "23806000074760021");
params.put("last_modified_time", "1631538698839");
response = invokeUrl
[
url: url
type: GET
parameters: params
connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks');
url.searchParams.append('page', '1');
url.searchParams.append('per_page', '10');
url.searchParams.append('filter', '{"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"}');
url.searchParams.append('sort_by', 'ASC(last_modified_time)');
url.searchParams.append('view_id', '23806000074760021');
url.searchParams.append('last_modified_time', '1631538698839');
const options = {
hostname: url.hostname,
path: url.pathname + url.search,
method: 'GET',
headers: {
'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
}
};
const req = https.request(options, (res) => {
let data = '';
res.on('data', (chunk) => { data += chunk; });
res.on('end', () => { console.log(JSON.parse(data)); });
});
req.on('error', (err) => { console.error(err); });
req.end();
require 'net/http'
require 'uri'
require 'json'
url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks")
params = {
"page" => "1",
"per_page" => "10",
"filter" => "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}",
"sort_by" => "ASC(last_modified_time)",
"view_id" => "23806000074760021",
"last_modified_time" => "1631538698839"
}
url.query = URI.encode_www_form(params)
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
response = http.request(request)
puts response.read_body
<?php
$params = [
'page' => '1',
'per_page' => '10',
'filter' => '{"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"}',
'sort_by' => 'ASC(last_modified_time)',
'view_id' => '23806000074760021',
'last_modified_time' => '1631538698839',
];
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks" . "?" . http_build_query($params);
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => $url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_HTTPHEADER => [
"Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
],
]);
$response = curl_exec($curl);
curl_close($curl);
echo $response;
import requests
url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks"
params = {
"page": "1",
"per_page": "10",
"filter": "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}",
"sort_by": "ASC(last_modified_time)",
"view_id": "23806000074760021",
"last_modified_time": "1631538698839"
}
headers = {
"Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
}
response = requests.get(url, headers=headers, params=params)
print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
int main(void) {
CURL *curl = curl_easy_init();
if (curl) {
char *enc_page = curl_easy_escape(curl, "1", 0);
char *enc_per_page = curl_easy_escape(curl, "10", 0);
char *enc_filter = curl_easy_escape(curl, "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}", 0);
char *enc_sort_by = curl_easy_escape(curl, "ASC(last_modified_time)", 0);
char *enc_view_id = curl_easy_escape(curl, "23806000074760021", 0);
char *enc_last_modified_time = curl_easy_escape(curl, "1631538698839", 0);
char url[2048];
snprintf(url, sizeof(url), "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks?page=%s&per_page=%s&filter=%s&sort_by=%s&view_id=%s&last_modified_time=%s", enc_page, enc_per_page, enc_filter, enc_sort_by, enc_view_id, enc_last_modified_time);
struct curl_slist *headers = NULL;
headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
curl_easy_setopt(curl, CURLOPT_URL, url);
curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
CURLcode res = curl_easy_perform(curl);
if (res != CURLE_OK)
fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));
curl_free(enc_page);
curl_free(enc_per_page);
curl_free(enc_filter);
curl_free(enc_sort_by);
curl_free(enc_view_id);
curl_free(enc_last_modified_time);
curl_slist_free_all(headers);
curl_easy_cleanup(curl);
}
return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;
var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
var query = HttpUtility.ParseQueryString(string.Empty);
query["page"] = "1";
query["per_page"] = "10";
query["filter"] = "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}";
query["sort_by"] = "ASC(last_modified_time)";
query["view_id"] = "23806000074760021";
query["last_modified_time"] = "1631538698839";
var uriBuilder = new UriBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks") { Query = query.ToString() };
var request = new HttpRequestMessage(HttpMethod.Get, uriBuilder.Uri);
var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>
static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
output->append((char*)contents, size * nmemb);
return size * nmemb;
}
int main() {
CURL* curl = curl_easy_init();
if (curl) {
std::string response;
char* enc_page = curl_easy_escape(curl, "1", 0);
char* enc_per_page = curl_easy_escape(curl, "10", 0);
char* enc_filter = curl_easy_escape(curl, "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}", 0);
char* enc_sort_by = curl_easy_escape(curl, "ASC(last_modified_time)", 0);
char* enc_view_id = curl_easy_escape(curl, "23806000074760021", 0);
char* enc_last_modified_time = curl_easy_escape(curl, "1631538698839", 0);
std::string url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks";
url += "?page=" + std::string(enc_page);
url += "&per_page=" + std::string(enc_per_page);
url += "&filter=" + std::string(enc_filter);
url += "&sort_by=" + std::string(enc_sort_by);
url += "&view_id=" + std::string(enc_view_id);
url += "&last_modified_time=" + std::string(enc_last_modified_time);
struct curl_slist* headers = NULL;
headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);
CURLcode res = curl_easy_perform(curl);
if (res == CURLE_OK)
std::cout << response << std::endl;
else
std::cerr << curl_easy_strerror(res) << std::endl;
curl_free(enc_page);
curl_free(enc_per_page);
curl_free(enc_filter);
curl_free(enc_sort_by);
curl_free(enc_view_id);
curl_free(enc_last_modified_time);
curl_slist_free_all(headers);
curl_easy_cleanup(curl);
}
return 0;
}
(require '[clj-http.client :as client])
(let [enc-page (java.net.URLEncoder/encode "1" "UTF-8")
enc-per_page (java.net.URLEncoder/encode "10" "UTF-8")
enc-filter (java.net.URLEncoder/encode "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}" "UTF-8")
enc-sort_by (java.net.URLEncoder/encode "ASC(last_modified_time)" "UTF-8")
enc-view_id (java.net.URLEncoder/encode "23806000074760021" "UTF-8")
enc-last_modified_time (java.net.URLEncoder/encode "1631538698839" "UTF-8")
url (str "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks" "?page=" enc-page "&per_page=" enc-per_page "&filter=" enc-filter "&sort_by=" enc-sort_by "&view_id=" enc-view_id "&last_modified_time=" enc-last_modified_time)]
(def response
(client/get url
{:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"}
:as :json}))
(println (:body response))
package main
import (
"fmt"
"io"
"net/http"
"net/url"
)
func main() {
req, _ := http.NewRequest("GET", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks", nil)
q := req.URL.Query()
q.Add("page", "1")
q.Add("per_page", "10")
q.Add("filter", "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}")
q.Add("sort_by", "ASC(last_modified_time)")
q.Add("view_id", "23806000074760021")
q.Add("last_modified_time", "1631538698839")
req.URL.RawQuery = q.Encode()
req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
resp, _ := http.DefaultClient.Do(req)
defer resp.Body.Close()
body, _ := io.ReadAll(resp.Body)
fmt.Println(string(body))
}
GET https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22field_name%22%3A%22name%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%22Design%22%5D%2C%22module_name%22%3A%22bug%22%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021&last_modified_time=1631538698839 HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks?page=1&per_page=10&filter=%7B%22criteria%22%3A%5B%7B%22field_name%22%3A%22name%22%2C%22criteria_condition%22%3A%22contains%22%2C%22value%22%3A%5B%22Design%22%5D%2C%22module_name%22%3A%22bug%22%7D%5D%2C%22pattern%22%3A%221%22%7D&sort_by=ASC%28last_modified_time%29&view_id=23806000074760021&last_modified_time=1631538698839
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();
SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();
URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks");
uriBuilder.addParameter("page", "1");
uriBuilder.addParameter("per_page", "10");
uriBuilder.addParameter("filter", "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}");
uriBuilder.addParameter("sort_by", "ASC(last_modified_time)");
uriBuilder.addParameter("view_id", "23806000074760021");
uriBuilder.addParameter("last_modified_time", "1631538698839");
HttpUriRequest requestObj = new HttpGet(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
HttpResponse response = httpclient.execute(requestObj);
HttpEntity responseEntity = response.getEntity();
Object responseObject = EntityUtils.toString(responseEntity);
String responseString = responseObject.toString();
const url = 'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks';
const params = new URLSearchParams({
'page': '1',
'per_page': '10',
'filter': '{"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"}',
'sort_by': 'ASC(last_modified_time)',
'view_id': '23806000074760021',
'last_modified_time': '1631538698839'
});
const options = {
method: 'GET',
headers: {
'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
}
};
fetch(url + '?' + params.toString(), options)
.then(response => response.json())
.then(data => console.log(data))
.catch(error => console.error(error));
page = 1
per_page = 10
filter = {"criteria":[{"field_name":"name","criteria_condition":"contains","value":["Design"],"module_name":"bug"}],"pattern":"1"}
sort_by = "ASC(last_modified_time)"
view_id = "23806000074760021"
last_modified_time = "1631538698839"import java.net.HttpURLConnection
import java.net.URL
import okhttp3.HttpUrl.Companion.toHttpUrl
fun main() {
val urlBuilder = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks".toHttpUrl().newBuilder()
urlBuilder.addQueryParameter("page", "1")
urlBuilder.addQueryParameter("per_page", "10")
urlBuilder.addQueryParameter("filter", "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}")
urlBuilder.addQueryParameter("sort_by", "ASC(last_modified_time)")
urlBuilder.addQueryParameter("view_id", "23806000074760021")
urlBuilder.addQueryParameter("last_modified_time", "1631538698839")
val url = URL(urlBuilder.build().toString())
val conn = url.openConnection() as HttpURLConnection
conn.requestMethod = "GET"
conn.setRequestProperty("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
val response = conn.inputStream.bufferedReader().readText()
println(response)
}
NSString *encodedPage = [@"1" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedPer_page = [@"10" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedFilter = [@"{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedSort_by = [@"ASC(last_modified_time)" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedView_id = [@"23806000074760021" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *encodedLast_modified_time = [@"1631538698839" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *urlString = [NSString stringWithFormat:@"https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks?page=%@&per_page=%@&filter=%@&sort_by=%@&view_id=%@&last_modified_time=%@", encodedPage, encodedPer_page, encodedFilter, encodedSort_by, encodedView_id, encodedLast_modified_time];
NSURL *url = [NSURL URLWithString:urlString];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
[request setHTTPMethod:@"GET"];
[request setValue:@"Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa" forHTTPHeaderField:@"Authorization"];
NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *task = [session dataTaskWithRequest:request
completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
NSString *result = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
NSLog(@"%@", result);
}];
[task resume];
open Lwt
open Cohttp_lwt_unix
let () =
let enc_page = Uri.pct_encode "1" in
let enc_per_page = Uri.pct_encode "10" in
let enc_filter = Uri.pct_encode "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}" in
let enc_sort_by = Uri.pct_encode "ASC(last_modified_time)" in
let enc_view_id = Uri.pct_encode "23806000074760021" in
let enc_last_modified_time = Uri.pct_encode "1631538698839" in
let uri = Uri.of_string ("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks" ^ "?page=" ^ enc_page ^ "&per_page=" ^ enc_per_page ^ "&filter=" ^ enc_filter ^ "&sort_by=" ^ enc_sort_by ^ "&view_id=" ^ enc_view_id ^ "&last_modified_time=" ^ enc_last_modified_time) in
let headers = Cohttp.Header.init ()
|> fun h -> Cohttp.Header.add h "Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
in
Lwt_main.run (
Client.get ~headers uri >>= fun (_, body) ->
Cohttp_lwt.Body.to_string body >|= fun s ->
print_endline s)
$headers = @{
"Authorization" = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
}
$params = @{
page = "1"
per_page = "10"
filter = "{`"criteria`":[{`"field_name`":`"name`",`"criteria_condition`":`"contains`",`"value`":[`"Design`"],`"module_name`":`"bug`"}],`"pattern`":`"1`"}"
sort_by = "ASC(last_modified_time)"
view_id = "23806000074760021"
last_modified_time = "1631538698839"
}
$queryString = ($params.GetEnumerator() | ForEach-Object { "$($_.Key)=$([System.Uri]::EscapeDataString($_.Value))" }) -join "&"
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks" + "?" + $queryString
$response = Invoke-RestMethod -Uri $url -Method GET -Headers $headers
$response | ConvertTo-Json
library(httr)
url <- "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks"
params <- list(
page = "1",
per_page = "10",
filter = "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}",
sort_by = "ASC(last_modified_time)",
view_id = "23806000074760021",
last_modified_time = "1631538698839"
)
response <- GET(
url,
add_headers(Authorization = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"),
query = params
)
content(response, "text")
import Foundation
var components = URLComponents(string: "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks")!
components.queryItems = [
URLQueryItem(name: "page", value: "1"),
URLQueryItem(name: "per_page", value: "10"),
URLQueryItem(name: "filter", value: "{\"criteria\":[{\"field_name\":\"name\",\"criteria_condition\":\"contains\",\"value\":[\"Design\"],\"module_name\":\"bug\"}],\"pattern\":\"1\"}"),
URLQueryItem(name: "sort_by", value: "ASC(last_modified_time)"),
URLQueryItem(name: "view_id", value: "23806000074760021"),
URLQueryItem(name: "last_modified_time", value: "1631538698839")
]
let url = components.url!
var request = URLRequest(url: url)
request.httpMethod = "GET"
request.setValue("Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa", forHTTPHeaderField: "Authorization")
let semaphore = DispatchSemaphore(value: 0)
let task = URLSession.shared.dataTask(with: request) { data, response, error in
if let data = data, let result = String(data: data, encoding: .utf8) {
print(result)
}
semaphore.signal()
}
task.resume()
semaphore.wait()
Sample Input
Sample Response
Possible Errors
Retrieve the details of a specific task in a project. Use this API to fetch metadata such as assignee, status, priority, and dates for a given task.
OAuth Scope:
ZohoProjects.tasks.READ
String
requiredUnique, immutable identifier of the portal in Zoho Projects. You can obtain it from the Get Portals API (the "id" field in the response).
String
requiredUnique, immutable identifier of the project within the specified portal. You can obtain it from the Get Projects API (the "id" field in the response).
String
requiredUnique, immutable identifier of the task within the specified project. You can obtain it from the Get Tasks API (the "id" field in the response).
Request Example
curl -X GET \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]";
response = invokeUrl
[
url: url
type: GET
connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]');
const options = {
hostname: url.hostname,
path: url.pathname + url.search,
method: 'GET',
headers: {
'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
}
};
const req = https.request(options, (res) => {
let data = '';
res.on('data', (chunk) => { data += chunk; });
res.on('end', () => { console.log(JSON.parse(data)); });
});
req.on('error', (err) => { console.error(err); });
req.end();
require 'net/http'
require 'uri'
require 'json'
url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
response = http.request(request)
puts response.read_body
<?php
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]";
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => $url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_CUSTOMREQUEST => "GET",
CURLOPT_HTTPHEADER => [
"Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
],
]);
$response = curl_exec($curl);
curl_close($curl);
echo $response;
import requests
url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]"
headers = {
"Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
}
response = requests.get(url, headers=headers)
print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
int main(void) {
CURL *curl = curl_easy_init();
if (curl) {
struct curl_slist *headers = NULL;
headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]");
curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
CURLcode res = curl_easy_perform(curl);
if (res != CURLE_OK)
fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));
curl_slist_free_all(headers);
curl_easy_cleanup(curl);
}
return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;
var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
var request = new HttpRequestMessage(HttpMethod.Get, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]");
var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>
static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
output->append((char*)contents, size * nmemb);
return size * nmemb;
}
int main() {
CURL* curl = curl_easy_init();
if (curl) {
std::string response;
struct curl_slist* headers = NULL;
headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]");
curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);
CURLcode res = curl_easy_perform(curl);
if (res == CURLE_OK)
std::cout << response << std::endl;
else
std::cerr << curl_easy_strerror(res) << std::endl;
curl_slist_free_all(headers);
curl_easy_cleanup(curl);
}
return 0;
}
(require '[clj-http.client :as client])
(def response
(client/get "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]"
{:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"}
:as :json}))
(println (:body response))
package main
import (
"fmt"
"io"
"net/http"
)
func main() {
req, _ := http.NewRequest("GET", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]", nil)
req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
resp, _ := http.DefaultClient.Do(req)
defer resp.Body.Close()
body, _ := io.ReadAll(resp.Body)
fmt.Println(string(body))
}
GET https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID] HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();
SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();
URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]");
HttpUriRequest requestObj = new HttpGet(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
HttpResponse response = httpclient.execute(requestObj);
HttpEntity responseEntity = response.getEntity();
Object responseObject = EntityUtils.toString(responseEntity);
String responseString = responseObject.toString();
const url = 'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]';
const options = {
method: 'GET',
headers: {
'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
}
};
fetch(url, options)
.then(response => response.json())
.then(data => console.log(data))
.catch(error => console.error(error));
import java.net.HttpURLConnection
import java.net.URL
import okhttp3.HttpUrl.Companion.toHttpUrl
fun main() {
val url = URL("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]")
val conn = url.openConnection() as HttpURLConnection
conn.requestMethod = "GET"
conn.setRequestProperty("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
val response = conn.inputStream.bufferedReader().readText()
println(response)
}
NSURL *url = [NSURL URLWithString:@"https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]"];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
[request setHTTPMethod:@"GET"];
[request setValue:@"Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa" forHTTPHeaderField:@"Authorization"];
NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *task = [session dataTaskWithRequest:request
completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
NSString *result = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
NSLog(@"%@", result);
}];
[task resume];
open Lwt
open Cohttp_lwt_unix
let () =
let uri = Uri.of_string "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]" in
let headers = Cohttp.Header.init ()
|> fun h -> Cohttp.Header.add h "Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
in
Lwt_main.run (
Client.get ~headers uri >>= fun (_, body) ->
Cohttp_lwt.Body.to_string body >|= fun s ->
print_endline s)
$headers = @{
"Authorization" = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
}
$response = Invoke-RestMethod -Uri "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]" -Method GET -Headers $headers
$response | ConvertTo-Json
library(httr)
url <- "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]"
response <- GET(
url,
add_headers(Authorization = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
)
content(response, "text")
import Foundation
let url = URL(string: "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks/[TASK_ID]")!
var request = URLRequest(url: url)
request.httpMethod = "GET"
request.setValue("Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa", forHTTPHeaderField: "Authorization")
let semaphore = DispatchSemaphore(value: 0)
let task = URLSession.shared.dataTask(with: request) { data, response, error in
if let data = data, let result = String(data: data, encoding: .utf8) {
print(result)
}
semaphore.signal()
}
task.resume()
semaphore.wait()
Sample Response
Possible Errors
Add a task to the project
OAuth Scope:
ZohoProjects.tasks.CREATE
String
requiredUnique, immutable identifier of the portal in Zoho Projects. You can obtain it from the Get Portals API (the "id" field in the response).
String
requiredUnique, immutable identifier of the project within the specified portal. You can obtain it from the Get Projects API (the "id" field in the response).
JSONObject
Enter the milestone details to associate with the task.
JSONObject
Enter the task list details. Uses the general task list when task list details are not provided; the project must have a general task list or an exception is thrown. To create one, use the Create Default Task List
JSONObject
Enter parent task details if sub task is need to be created
String
requiredEnter the task name
String
max length : 80000Enter the task description
JSONObject
max length : 1000Enter the task status details if not provided default open will be taken
String
Enter the task priority Possible values are none,low,medium,high
JSONObject
Enter the start after of the task
String
regex : ISO-8601Enter the start date of the task in ISO 8601 format. Use yyyy-MM-dd'T'HH:mm:ss'Z' for UTC or yyyy-MM-dd'T'HH:mm:ss[+|-]HH:mm for other time zones.
String
regex : ISO-8601Enter the end date of the task in ISO 8601 format. Use yyyy-MM-dd'T'HH:mm:ss'Z' for UTC or yyyy-MM-dd'T'HH:mm:ss[+|-]HH:mm for other time zones.
JSONObject
Enter the duration of the task
int
Enter the task completion percentage
String
Enter the billing type for the task Possible values are none,billable,non_billable
JSONArray
max length : 10000Enter the IDs of files to be uploaded You can obtain it from the Get Project Attachments API (the "attachment_id" field in the response).
JSONArray
max length : 2500Enter the WorkDrive resource IDs of the files to associate. The WorkDrive resource ID is different from the attachment ID in Zoho Projects. You can pass up to 50 IDs. To get the thirdPartyId, refer to the WorkDrive API User who does not have upload permission to the folder/team folder can upload file upto 20 MB only.
JSONObject
max length : 1600000Enter the task owner name and work details
JSONArray
max length : 10000Enter the tags for the task
JSONArray
max length : 100000Add or remove teams associated with the task
JSONObject
max length : 100000Enter recurrence details of the task
JSONObject
max length : 100000Enter the Reminder details of the task
JSONObject
max length : 100000Enter the Budget details of the task
String
Enter the value for a task custom field. Replace <field_name> with the custom field's API name in snake_case, as listed in the Custom Fields Guide.
Note: The type is shown as String by default since most basic custom fields accept string values. The actual expected value format and input structure depend on the custom field type.
Refer to the Custom Fields Guide for details.
Request Example
curl -X POST \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa' \
-H 'Content-Type: application/json' \
-d '{"milestone":{"id":"4000000062001"},"tasklist":{"id":"4000000062001"},"parental_info":{"parent_task_id":"4000000005670"},"name":"Set Up CI/CD Pipeline for Staging Environment","description":false,"status":{"id":"4000000062001"},"priority":"high","start_after":{"value":"5","unit":"hours_per_day"},"start_date":"2024-12-16T09:00:00.000Z","end_date":"2024-12-19T18:00:00.000Z","duration":{"value":"5","type":"days"},"completion_percentage":0,"billing_type":false,"attachments":false,"thirdparty_id":["9if2g8aa1c0f0e1234567890abcdef123456"],"owners_and_work":{"owners":[{"add":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"remove":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com"}],"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"work_type":"standard","unit":"hours_per_day","copy_task_duration":"true","refresh_business_hours":"false"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"teams":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"recurrence":{"frequency":"daily","interval":1,"end_after_occurrences":"10","set_to_previous_businessday":"false","next_recurrence_after_close":"true","trigger_type":"first_to_occur","date_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"scheduler_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"retain_comments":"false","retain_subtasks":"false","retain_config":{"comments":false,"billing_type":false,"followers":false,"description":false,"subtasks":false,"tags":false,"attachments":false,"teams":false}},"reminder":{"reminder_criteria":"on","field_type":"start_date","custom_date":"2023-12-20","no_of_duration":"2","time":"22:00","duration_type":"days","emailtemplate_id":"4000000008003","reminder_notify_users":[{"type":"days","values":["4000000002055"]}]},"budget_info":{"rate_per_hour":50,"budget":"12345:00","threshold":"234:00","hourly_budget":"40:00","hourly_budget_threshold":"35:00","revenue_budget":5000,"cost_rate_per_hour":30},"<field_name>":"In Progress"}'
url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks";
params = Map();
params.put("milestone", {"id":"4000000062001"});
params.put("tasklist", {"id":"4000000062001"});
params.put("parental_info", {"parent_task_id":"4000000005670"});
params.put("name", "Set Up CI/CD Pipeline for Staging Environment");
params.put("description", false);
params.put("status", {"id":"4000000062001"});
params.put("priority", "high");
params.put("start_after", {"value":"5","unit":"hours_per_day"});
params.put("start_date", "2024-12-16T09:00:00.000Z");
params.put("end_date", "2024-12-19T18:00:00.000Z");
params.put("duration", {"value":"5","type":"days"});
params.put("completion_percentage", 0);
params.put("billing_type", false);
params.put("attachments", false);
params.put("thirdparty_id", ["9if2g8aa1c0f0e1234567890abcdef123456"]);
params.put("owners_and_work", {"owners":[{"add":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"remove":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com"}],"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"work_type":"standard","unit":"hours_per_day","copy_task_duration":"true","refresh_business_hours":"false"});
params.put("tags", [{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}]);
params.put("teams", [{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}]);
params.put("recurrence", {"frequency":"daily","interval":1,"end_after_occurrences":"10","set_to_previous_businessday":"false","next_recurrence_after_close":"true","trigger_type":"first_to_occur","date_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"scheduler_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"retain_comments":"false","retain_subtasks":"false","retain_config":{"comments":false,"billing_type":false,"followers":false,"description":false,"subtasks":false,"tags":false,"attachments":false,"teams":false}});
params.put("reminder", {"reminder_criteria":"on","field_type":"start_date","custom_date":"2023-12-20","no_of_duration":"2","time":"22:00","duration_type":"days","emailtemplate_id":"4000000008003","reminder_notify_users":[{"type":"days","values":["4000000002055"]}]});
params.put("budget_info", {"rate_per_hour":50,"budget":"12345:00","threshold":"234:00","hourly_budget":"40:00","hourly_budget_threshold":"35:00","revenue_budget":5000,"cost_rate_per_hour":30});
params.put("<field_name>", "In Progress");
response = invokeUrl
[
url: url
type: POST
parameters: params.toString()
connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks');
const payload = JSON.stringify({"milestone":{"id":"4000000062001"},"tasklist":{"id":"4000000062001"},"parental_info":{"parent_task_id":"4000000005670"},"name":"Set Up CI/CD Pipeline for Staging Environment","description":false,"status":{"id":"4000000062001"},"priority":"high","start_after":{"value":"5","unit":"hours_per_day"},"start_date":"2024-12-16T09:00:00.000Z","end_date":"2024-12-19T18:00:00.000Z","duration":{"value":"5","type":"days"},"completion_percentage":0,"billing_type":false,"attachments":false,"thirdparty_id":["9if2g8aa1c0f0e1234567890abcdef123456"],"owners_and_work":{"owners":[{"add":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"remove":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com"}],"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"work_type":"standard","unit":"hours_per_day","copy_task_duration":"true","refresh_business_hours":"false"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"teams":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"recurrence":{"frequency":"daily","interval":1,"end_after_occurrences":"10","set_to_previous_businessday":"false","next_recurrence_after_close":"true","trigger_type":"first_to_occur","date_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"scheduler_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"retain_comments":"false","retain_subtasks":"false","retain_config":{"comments":false,"billing_type":false,"followers":false,"description":false,"subtasks":false,"tags":false,"attachments":false,"teams":false}},"reminder":{"reminder_criteria":"on","field_type":"start_date","custom_date":"2023-12-20","no_of_duration":"2","time":"22:00","duration_type":"days","emailtemplate_id":"4000000008003","reminder_notify_users":[{"type":"days","values":["4000000002055"]}]},"budget_info":{"rate_per_hour":50,"budget":"12345:00","threshold":"234:00","hourly_budget":"40:00","hourly_budget_threshold":"35:00","revenue_budget":5000,"cost_rate_per_hour":30},"<field_name>":"In Progress"});
const options = {
hostname: url.hostname,
path: url.pathname + url.search,
method: 'POST',
headers: {
'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa',
'Content-Type': 'application/json',
'Content-Length': Buffer.byteLength(payload)
}
};
const req = https.request(options, (res) => {
let data = '';
res.on('data', (chunk) => { data += chunk; });
res.on('end', () => { console.log(JSON.parse(data)); });
});
req.on('error', (err) => { console.error(err); });
req.write(payload);
req.end();
require 'net/http'
require 'uri'
require 'json'
url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
request["Content-Type"] = "application/json"
request.body = '{"milestone":{"id":"4000000062001"},"tasklist":{"id":"4000000062001"},"parental_info":{"parent_task_id":"4000000005670"},"name":"Set Up CI/CD Pipeline for Staging Environment","description":false,"status":{"id":"4000000062001"},"priority":"high","start_after":{"value":"5","unit":"hours_per_day"},"start_date":"2024-12-16T09:00:00.000Z","end_date":"2024-12-19T18:00:00.000Z","duration":{"value":"5","type":"days"},"completion_percentage":0,"billing_type":false,"attachments":false,"thirdparty_id":["9if2g8aa1c0f0e1234567890abcdef123456"],"owners_and_work":{"owners":[{"add":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"remove":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com"}],"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"work_type":"standard","unit":"hours_per_day","copy_task_duration":"true","refresh_business_hours":"false"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"teams":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"recurrence":{"frequency":"daily","interval":1,"end_after_occurrences":"10","set_to_previous_businessday":"false","next_recurrence_after_close":"true","trigger_type":"first_to_occur","date_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"scheduler_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"retain_comments":"false","retain_subtasks":"false","retain_config":{"comments":false,"billing_type":false,"followers":false,"description":false,"subtasks":false,"tags":false,"attachments":false,"teams":false}},"reminder":{"reminder_criteria":"on","field_type":"start_date","custom_date":"2023-12-20","no_of_duration":"2","time":"22:00","duration_type":"days","emailtemplate_id":"4000000008003","reminder_notify_users":[{"type":"days","values":["4000000002055"]}]},"budget_info":{"rate_per_hour":50,"budget":"12345:00","threshold":"234:00","hourly_budget":"40:00","hourly_budget_threshold":"35:00","revenue_budget":5000,"cost_rate_per_hour":30},"<field_name>":"In Progress"}'
response = http.request(request)
puts response.read_body
<?php
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks";
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => $url,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => '{"milestone":{"id":"4000000062001"},"tasklist":{"id":"4000000062001"},"parental_info":{"parent_task_id":"4000000005670"},"name":"Set Up CI/CD Pipeline for Staging Environment","description":false,"status":{"id":"4000000062001"},"priority":"high","start_after":{"value":"5","unit":"hours_per_day"},"start_date":"2024-12-16T09:00:00.000Z","end_date":"2024-12-19T18:00:00.000Z","duration":{"value":"5","type":"days"},"completion_percentage":0,"billing_type":false,"attachments":false,"thirdparty_id":["9if2g8aa1c0f0e1234567890abcdef123456"],"owners_and_work":{"owners":[{"add":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"remove":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com"}],"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"work_type":"standard","unit":"hours_per_day","copy_task_duration":"true","refresh_business_hours":"false"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"teams":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"recurrence":{"frequency":"daily","interval":1,"end_after_occurrences":"10","set_to_previous_businessday":"false","next_recurrence_after_close":"true","trigger_type":"first_to_occur","date_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"scheduler_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"retain_comments":"false","retain_subtasks":"false","retain_config":{"comments":false,"billing_type":false,"followers":false,"description":false,"subtasks":false,"tags":false,"attachments":false,"teams":false}},"reminder":{"reminder_criteria":"on","field_type":"start_date","custom_date":"2023-12-20","no_of_duration":"2","time":"22:00","duration_type":"days","emailtemplate_id":"4000000008003","reminder_notify_users":[{"type":"days","values":["4000000002055"]}]},"budget_info":{"rate_per_hour":50,"budget":"12345:00","threshold":"234:00","hourly_budget":"40:00","hourly_budget_threshold":"35:00","revenue_budget":5000,"cost_rate_per_hour":30},"<field_name>":"In Progress"}',
CURLOPT_HTTPHEADER => [
"Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
curl_close($curl);
echo $response;
import requests
url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks"
headers = {
"Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
"Content-Type": "application/json",
}
payload = '{"milestone":{"id":"4000000062001"},"tasklist":{"id":"4000000062001"},"parental_info":{"parent_task_id":"4000000005670"},"name":"Set Up CI/CD Pipeline for Staging Environment","description":false,"status":{"id":"4000000062001"},"priority":"high","start_after":{"value":"5","unit":"hours_per_day"},"start_date":"2024-12-16T09:00:00.000Z","end_date":"2024-12-19T18:00:00.000Z","duration":{"value":"5","type":"days"},"completion_percentage":0,"billing_type":false,"attachments":false,"thirdparty_id":["9if2g8aa1c0f0e1234567890abcdef123456"],"owners_and_work":{"owners":[{"add":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"remove":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com"}],"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"work_type":"standard","unit":"hours_per_day","copy_task_duration":"true","refresh_business_hours":"false"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"teams":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"recurrence":{"frequency":"daily","interval":1,"end_after_occurrences":"10","set_to_previous_businessday":"false","next_recurrence_after_close":"true","trigger_type":"first_to_occur","date_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"scheduler_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"retain_comments":"false","retain_subtasks":"false","retain_config":{"comments":false,"billing_type":false,"followers":false,"description":false,"subtasks":false,"tags":false,"attachments":false,"teams":false}},"reminder":{"reminder_criteria":"on","field_type":"start_date","custom_date":"2023-12-20","no_of_duration":"2","time":"22:00","duration_type":"days","emailtemplate_id":"4000000008003","reminder_notify_users":[{"type":"days","values":["4000000002055"]}]},"budget_info":{"rate_per_hour":50,"budget":"12345:00","threshold":"234:00","hourly_budget":"40:00","hourly_budget_threshold":"35:00","revenue_budget":5000,"cost_rate_per_hour":30},"<field_name>":"In Progress"}'
response = requests.post(url, headers=headers, data=payload)
print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>
int main(void) {
CURL *curl = curl_easy_init();
if (curl) {
struct curl_slist *headers = NULL;
headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
headers = curl_slist_append(headers, "Content-Type: application/json");
curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks");
curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "{\"milestone\":{\"id\":\"4000000062001\"},\"tasklist\":{\"id\":\"4000000062001\"},\"parental_info\":{\"parent_task_id\":\"4000000005670\"},\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"description\":false,\"status\":{\"id\":\"4000000062001\"},\"priority\":\"high\",\"start_after\":{\"value\":\"5\",\"unit\":\"hours_per_day\"},\"start_date\":\"2024-12-16T09:00:00.000Z\",\"end_date\":\"2024-12-19T18:00:00.000Z\",\"duration\":{\"value\":\"5\",\"type\":\"days\"},\"completion_percentage\":0,\"billing_type\":false,\"attachments\":false,\"thirdparty_id\":[\"9if2g8aa1c0f0e1234567890abcdef123456\"],\"owners_and_work\":{\"owners\":[{\"add\":[{\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\",\"work_values\":\"08:00\"}],\"remove\":[{\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\"}],\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\",\"work_values\":\"08:00\"}],\"work_type\":\"standard\",\"unit\":\"hours_per_day\",\"copy_task_duration\":\"true\",\"refresh_business_hours\":\"false\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"teams\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"recurrence\":{\"frequency\":\"daily\",\"interval\":1,\"end_after_occurrences\":\"10\",\"set_to_previous_businessday\":\"false\",\"next_recurrence_after_close\":\"true\",\"trigger_type\":\"first_to_occur\",\"date_based\":{\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"schedule_datetime\":\"2024-12-16T09:00:00.000Z\",\"repetative_type\":\"daily\",\"time_span\":1,\"days_of_week\":[\"1\"],\"months_of_year\":[\"1\"],\"repeat_on_type\":0,\"repeat_on_value\":\"1\",\"ends_after_type\":\"none\",\"ends_after_value\":\"20\",\"skip_type\":\"skip\",\"mail_to_user\":{\"zpuid\":[\"4000000002055\"]},\"duration_type\":\"days\",\"no_of_duration\":\"2\",\"field_name\":\"status\",\"time\":\"22:00\"},\"scheduler_based\":{\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"schedule_datetime\":\"2024-12-16T09:00:00.000Z\",\"repetative_type\":\"daily\",\"time_span\":1,\"days_of_week\":[\"1\"],\"months_of_year\":[\"1\"],\"repeat_on_type\":0,\"repeat_on_value\":\"1\",\"ends_after_type\":\"none\",\"ends_after_value\":\"20\",\"skip_type\":\"skip\",\"mail_to_user\":{\"zpuid\":[\"4000000002055\"]},\"duration_type\":\"days\",\"no_of_duration\":\"2\",\"field_name\":\"status\",\"time\":\"22:00\"},\"retain_comments\":\"false\",\"retain_subtasks\":\"false\",\"retain_config\":{\"comments\":false,\"billing_type\":false,\"followers\":false,\"description\":false,\"subtasks\":false,\"tags\":false,\"attachments\":false,\"teams\":false}},\"reminder\":{\"reminder_criteria\":\"on\",\"field_type\":\"start_date\",\"custom_date\":\"2023-12-20\",\"no_of_duration\":\"2\",\"time\":\"22:00\",\"duration_type\":\"days\",\"emailtemplate_id\":\"4000000008003\",\"reminder_notify_users\":[{\"type\":\"days\",\"values\":[\"4000000002055\"]}]},\"budget_info\":{\"rate_per_hour\":50,\"budget\":\"12345:00\",\"threshold\":\"234:00\",\"hourly_budget\":\"40:00\",\"hourly_budget_threshold\":\"35:00\",\"revenue_budget\":5000,\"cost_rate_per_hour\":30},\"<field_name>\":\"In Progress\"}");
CURLcode res = curl_easy_perform(curl);
if (res != CURLE_OK)
fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));
curl_slist_free_all(headers);
curl_easy_cleanup(curl);
}
return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;
var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
var request = new HttpRequestMessage(HttpMethod.Post, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks");
request.Content = new StringContent(
@"{""milestone"":{""id"":""4000000062001""},""tasklist"":{""id"":""4000000062001""},""parental_info"":{""parent_task_id"":""4000000005670""},""name"":""Set Up CI/CD Pipeline for Staging Environment"",""description"":false,""status"":{""id"":""4000000062001""},""priority"":""high"",""start_after"":{""value"":""5"",""unit"":""hours_per_day""},""start_date"":""2024-12-16T09:00:00.000Z"",""end_date"":""2024-12-19T18:00:00.000Z"",""duration"":{""value"":""5"",""type"":""days""},""completion_percentage"":0,""billing_type"":false,""attachments"":false,""thirdparty_id"":[""9if2g8aa1c0f0e1234567890abcdef123456""],""owners_and_work"":{""owners"":[{""add"":[{""zpuid"":[""4000000002055""],""zuid"":""16469208"",""email"":""richard.santos@zylker.com"",""work_values"":""08:00""}],""remove"":[{""zpuid"":[""4000000002055""],""zuid"":""16469208"",""email"":""richard.santos@zylker.com""}],""zpuid"":[""4000000002055""],""zuid"":""16469208"",""email"":""richard.santos@zylker.com"",""work_values"":""08:00""}],""work_type"":""standard"",""unit"":""hours_per_day"",""copy_task_duration"":""true"",""refresh_business_hours"":""false""},""tags"":[{""add"":[{""id"":""4000000062001""}],""remove"":[{""id"":""4000000062001""}],""id"":""4000000062001""}],""teams"":[{""add"":[{""id"":""4000000062001""}],""remove"":[{""id"":""4000000062001""}],""id"":""4000000062001""}],""recurrence"":{""frequency"":""daily"",""interval"":1,""end_after_occurrences"":""10"",""set_to_previous_businessday"":""false"",""next_recurrence_after_close"":""true"",""trigger_type"":""first_to_occur"",""date_based"":{""name"":""Set Up CI/CD Pipeline for Staging Environment"",""schedule_datetime"":""2024-12-16T09:00:00.000Z"",""repetative_type"":""daily"",""time_span"":1,""days_of_week"":[""1""],""months_of_year"":[""1""],""repeat_on_type"":0,""repeat_on_value"":""1"",""ends_after_type"":""none"",""ends_after_value"":""20"",""skip_type"":""skip"",""mail_to_user"":{""zpuid"":[""4000000002055""]},""duration_type"":""days"",""no_of_duration"":""2"",""field_name"":""status"",""time"":""22:00""},""scheduler_based"":{""name"":""Set Up CI/CD Pipeline for Staging Environment"",""schedule_datetime"":""2024-12-16T09:00:00.000Z"",""repetative_type"":""daily"",""time_span"":1,""days_of_week"":[""1""],""months_of_year"":[""1""],""repeat_on_type"":0,""repeat_on_value"":""1"",""ends_after_type"":""none"",""ends_after_value"":""20"",""skip_type"":""skip"",""mail_to_user"":{""zpuid"":[""4000000002055""]},""duration_type"":""days"",""no_of_duration"":""2"",""field_name"":""status"",""time"":""22:00""},""retain_comments"":""false"",""retain_subtasks"":""false"",""retain_config"":{""comments"":false,""billing_type"":false,""followers"":false,""description"":false,""subtasks"":false,""tags"":false,""attachments"":false,""teams"":false}},""reminder"":{""reminder_criteria"":""on"",""field_type"":""start_date"",""custom_date"":""2023-12-20"",""no_of_duration"":""2"",""time"":""22:00"",""duration_type"":""days"",""emailtemplate_id"":""4000000008003"",""reminder_notify_users"":[{""type"":""days"",""values"":[""4000000002055""]}]},""budget_info"":{""rate_per_hour"":50,""budget"":""12345:00"",""threshold"":""234:00"",""hourly_budget"":""40:00"",""hourly_budget_threshold"":""35:00"",""revenue_budget"":5000,""cost_rate_per_hour"":30},""<field_name>"":""In Progress""}",
Encoding.UTF8,
"application/json"
);
var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>
static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
output->append((char*)contents, size * nmemb);
return size * nmemb;
}
int main() {
CURL* curl = curl_easy_init();
if (curl) {
std::string response;
struct curl_slist* headers = NULL;
headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
headers = curl_slist_append(headers, "Content-Type: application/json");
curl_easy_setopt(curl, CURLOPT_URL, "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks");
curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "POST");
curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);
curl_easy_setopt(curl, CURLOPT_POSTFIELDS, "{\"milestone\":{\"id\":\"4000000062001\"},\"tasklist\":{\"id\":\"4000000062001\"},\"parental_info\":{\"parent_task_id\":\"4000000005670\"},\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"description\":false,\"status\":{\"id\":\"4000000062001\"},\"priority\":\"high\",\"start_after\":{\"value\":\"5\",\"unit\":\"hours_per_day\"},\"start_date\":\"2024-12-16T09:00:00.000Z\",\"end_date\":\"2024-12-19T18:00:00.000Z\",\"duration\":{\"value\":\"5\",\"type\":\"days\"},\"completion_percentage\":0,\"billing_type\":false,\"attachments\":false,\"thirdparty_id\":[\"9if2g8aa1c0f0e1234567890abcdef123456\"],\"owners_and_work\":{\"owners\":[{\"add\":[{\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\",\"work_values\":\"08:00\"}],\"remove\":[{\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\"}],\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\",\"work_values\":\"08:00\"}],\"work_type\":\"standard\",\"unit\":\"hours_per_day\",\"copy_task_duration\":\"true\",\"refresh_business_hours\":\"false\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"teams\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"recurrence\":{\"frequency\":\"daily\",\"interval\":1,\"end_after_occurrences\":\"10\",\"set_to_previous_businessday\":\"false\",\"next_recurrence_after_close\":\"true\",\"trigger_type\":\"first_to_occur\",\"date_based\":{\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"schedule_datetime\":\"2024-12-16T09:00:00.000Z\",\"repetative_type\":\"daily\",\"time_span\":1,\"days_of_week\":[\"1\"],\"months_of_year\":[\"1\"],\"repeat_on_type\":0,\"repeat_on_value\":\"1\",\"ends_after_type\":\"none\",\"ends_after_value\":\"20\",\"skip_type\":\"skip\",\"mail_to_user\":{\"zpuid\":[\"4000000002055\"]},\"duration_type\":\"days\",\"no_of_duration\":\"2\",\"field_name\":\"status\",\"time\":\"22:00\"},\"scheduler_based\":{\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"schedule_datetime\":\"2024-12-16T09:00:00.000Z\",\"repetative_type\":\"daily\",\"time_span\":1,\"days_of_week\":[\"1\"],\"months_of_year\":[\"1\"],\"repeat_on_type\":0,\"repeat_on_value\":\"1\",\"ends_after_type\":\"none\",\"ends_after_value\":\"20\",\"skip_type\":\"skip\",\"mail_to_user\":{\"zpuid\":[\"4000000002055\"]},\"duration_type\":\"days\",\"no_of_duration\":\"2\",\"field_name\":\"status\",\"time\":\"22:00\"},\"retain_comments\":\"false\",\"retain_subtasks\":\"false\",\"retain_config\":{\"comments\":false,\"billing_type\":false,\"followers\":false,\"description\":false,\"subtasks\":false,\"tags\":false,\"attachments\":false,\"teams\":false}},\"reminder\":{\"reminder_criteria\":\"on\",\"field_type\":\"start_date\",\"custom_date\":\"2023-12-20\",\"no_of_duration\":\"2\",\"time\":\"22:00\",\"duration_type\":\"days\",\"emailtemplate_id\":\"4000000008003\",\"reminder_notify_users\":[{\"type\":\"days\",\"values\":[\"4000000002055\"]}]},\"budget_info\":{\"rate_per_hour\":50,\"budget\":\"12345:00\",\"threshold\":\"234:00\",\"hourly_budget\":\"40:00\",\"hourly_budget_threshold\":\"35:00\",\"revenue_budget\":5000,\"cost_rate_per_hour\":30},\"<field_name>\":\"In Progress\"}");
CURLcode res = curl_easy_perform(curl);
if (res == CURLE_OK)
std::cout << response << std::endl;
else
std::cerr << curl_easy_strerror(res) << std::endl;
curl_slist_free_all(headers);
curl_easy_cleanup(curl);
}
return 0;
}
(require '[clj-http.client :as client])
(def response
(client/post "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks"
{:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
"Content-Type" "application/json"}
:body "{\"milestone\":{\"id\":\"4000000062001\"},\"tasklist\":{\"id\":\"4000000062001\"},\"parental_info\":{\"parent_task_id\":\"4000000005670\"},\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"description\":false,\"status\":{\"id\":\"4000000062001\"},\"priority\":\"high\",\"start_after\":{\"value\":\"5\",\"unit\":\"hours_per_day\"},\"start_date\":\"2024-12-16T09:00:00.000Z\",\"end_date\":\"2024-12-19T18:00:00.000Z\",\"duration\":{\"value\":\"5\",\"type\":\"days\"},\"completion_percentage\":0,\"billing_type\":false,\"attachments\":false,\"thirdparty_id\":[\"9if2g8aa1c0f0e1234567890abcdef123456\"],\"owners_and_work\":{\"owners\":[{\"add\":[{\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\",\"work_values\":\"08:00\"}],\"remove\":[{\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\"}],\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\",\"work_values\":\"08:00\"}],\"work_type\":\"standard\",\"unit\":\"hours_per_day\",\"copy_task_duration\":\"true\",\"refresh_business_hours\":\"false\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"teams\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"recurrence\":{\"frequency\":\"daily\",\"interval\":1,\"end_after_occurrences\":\"10\",\"set_to_previous_businessday\":\"false\",\"next_recurrence_after_close\":\"true\",\"trigger_type\":\"first_to_occur\",\"date_based\":{\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"schedule_datetime\":\"2024-12-16T09:00:00.000Z\",\"repetative_type\":\"daily\",\"time_span\":1,\"days_of_week\":[\"1\"],\"months_of_year\":[\"1\"],\"repeat_on_type\":0,\"repeat_on_value\":\"1\",\"ends_after_type\":\"none\",\"ends_after_value\":\"20\",\"skip_type\":\"skip\",\"mail_to_user\":{\"zpuid\":[\"4000000002055\"]},\"duration_type\":\"days\",\"no_of_duration\":\"2\",\"field_name\":\"status\",\"time\":\"22:00\"},\"scheduler_based\":{\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"schedule_datetime\":\"2024-12-16T09:00:00.000Z\",\"repetative_type\":\"daily\",\"time_span\":1,\"days_of_week\":[\"1\"],\"months_of_year\":[\"1\"],\"repeat_on_type\":0,\"repeat_on_value\":\"1\",\"ends_after_type\":\"none\",\"ends_after_value\":\"20\",\"skip_type\":\"skip\",\"mail_to_user\":{\"zpuid\":[\"4000000002055\"]},\"duration_type\":\"days\",\"no_of_duration\":\"2\",\"field_name\":\"status\",\"time\":\"22:00\"},\"retain_comments\":\"false\",\"retain_subtasks\":\"false\",\"retain_config\":{\"comments\":false,\"billing_type\":false,\"followers\":false,\"description\":false,\"subtasks\":false,\"tags\":false,\"attachments\":false,\"teams\":false}},\"reminder\":{\"reminder_criteria\":\"on\",\"field_type\":\"start_date\",\"custom_date\":\"2023-12-20\",\"no_of_duration\":\"2\",\"time\":\"22:00\",\"duration_type\":\"days\",\"emailtemplate_id\":\"4000000008003\",\"reminder_notify_users\":[{\"type\":\"days\",\"values\":[\"4000000002055\"]}]},\"budget_info\":{\"rate_per_hour\":50,\"budget\":\"12345:00\",\"threshold\":\"234:00\",\"hourly_budget\":\"40:00\",\"hourly_budget_threshold\":\"35:00\",\"revenue_budget\":5000,\"cost_rate_per_hour\":30},\"<field_name>\":\"In Progress\"}"
:as :json}))
(println (:body response))
package main
import (
"fmt"
"io"
"net/http"
"strings"
)
func main() {
payload := strings.NewReader("{\"milestone\":{\"id\":\"4000000062001\"},\"tasklist\":{\"id\":\"4000000062001\"},\"parental_info\":{\"parent_task_id\":\"4000000005670\"},\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"description\":false,\"status\":{\"id\":\"4000000062001\"},\"priority\":\"high\",\"start_after\":{\"value\":\"5\",\"unit\":\"hours_per_day\"},\"start_date\":\"2024-12-16T09:00:00.000Z\",\"end_date\":\"2024-12-19T18:00:00.000Z\",\"duration\":{\"value\":\"5\",\"type\":\"days\"},\"completion_percentage\":0,\"billing_type\":false,\"attachments\":false,\"thirdparty_id\":[\"9if2g8aa1c0f0e1234567890abcdef123456\"],\"owners_and_work\":{\"owners\":[{\"add\":[{\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\",\"work_values\":\"08:00\"}],\"remove\":[{\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\"}],\"zpuid\":[\"4000000002055\"],\"zuid\":\"16469208\",\"email\":\"richard.santos@zylker.com\",\"work_values\":\"08:00\"}],\"work_type\":\"standard\",\"unit\":\"hours_per_day\",\"copy_task_duration\":\"true\",\"refresh_business_hours\":\"false\"},\"tags\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"teams\":[{\"add\":[{\"id\":\"4000000062001\"}],\"remove\":[{\"id\":\"4000000062001\"}],\"id\":\"4000000062001\"}],\"recurrence\":{\"frequency\":\"daily\",\"interval\":1,\"end_after_occurrences\":\"10\",\"set_to_previous_businessday\":\"false\",\"next_recurrence_after_close\":\"true\",\"trigger_type\":\"first_to_occur\",\"date_based\":{\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"schedule_datetime\":\"2024-12-16T09:00:00.000Z\",\"repetative_type\":\"daily\",\"time_span\":1,\"days_of_week\":[\"1\"],\"months_of_year\":[\"1\"],\"repeat_on_type\":0,\"repeat_on_value\":\"1\",\"ends_after_type\":\"none\",\"ends_after_value\":\"20\",\"skip_type\":\"skip\",\"mail_to_user\":{\"zpuid\":[\"4000000002055\"]},\"duration_type\":\"days\",\"no_of_duration\":\"2\",\"field_name\":\"status\",\"time\":\"22:00\"},\"scheduler_based\":{\"name\":\"Set Up CI/CD Pipeline for Staging Environment\",\"schedule_datetime\":\"2024-12-16T09:00:00.000Z\",\"repetative_type\":\"daily\",\"time_span\":1,\"days_of_week\":[\"1\"],\"months_of_year\":[\"1\"],\"repeat_on_type\":0,\"repeat_on_value\":\"1\",\"ends_after_type\":\"none\",\"ends_after_value\":\"20\",\"skip_type\":\"skip\",\"mail_to_user\":{\"zpuid\":[\"4000000002055\"]},\"duration_type\":\"days\",\"no_of_duration\":\"2\",\"field_name\":\"status\",\"time\":\"22:00\"},\"retain_comments\":\"false\",\"retain_subtasks\":\"false\",\"retain_config\":{\"comments\":false,\"billing_type\":false,\"followers\":false,\"description\":false,\"subtasks\":false,\"tags\":false,\"attachments\":false,\"teams\":false}},\"reminder\":{\"reminder_criteria\":\"on\",\"field_type\":\"start_date\",\"custom_date\":\"2023-12-20\",\"no_of_duration\":\"2\",\"time\":\"22:00\",\"duration_type\":\"days\",\"emailtemplate_id\":\"4000000008003\",\"reminder_notify_users\":[{\"type\":\"days\",\"values\":[\"4000000002055\"]}]},\"budget_info\":{\"rate_per_hour\":50,\"budget\":\"12345:00\",\"threshold\":\"234:00\",\"hourly_budget\":\"40:00\",\"hourly_budget_threshold\":\"35:00\",\"revenue_budget\":5000,\"cost_rate_per_hour\":30},\"<field_name>\":\"In Progress\"}")
req, _ := http.NewRequest("POST", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks", payload)
req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")
req.Header.Add("Content-Type", "application/json")
resp, _ := http.DefaultClient.Do(req)
defer resp.Body.Close()
body, _ := io.ReadAll(resp.Body)
fmt.Println(string(body))
}
POST https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
Content-Type: application/json
{"milestone":{"id":"4000000062001"},"tasklist":{"id":"4000000062001"},"parental_info":{"parent_task_id":"4000000005670"},"name":"Set Up CI/CD Pipeline for Staging Environment","description":false,"status":{"id":"4000000062001"},"priority":"high","start_after":{"value":"5","unit":"hours_per_day"},"start_date":"2024-12-16T09:00:00.000Z","end_date":"2024-12-19T18:00:00.000Z","duration":{"value":"5","type":"days"},"completion_percentage":0,"billing_type":false,"attachments":false,"thirdparty_id":["9if2g8aa1c0f0e1234567890abcdef123456"],"owners_and_work":{"owners":[{"add":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"remove":[{"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com"}],"zpuid":["4000000002055"],"zuid":"16469208","email":"richard.santos@zylker.com","work_values":"08:00"}],"work_type":"standard","unit":"hours_per_day","copy_task_duration":"true","refresh_business_hours":"false"},"tags":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"teams":[{"add":[{"id":"4000000062001"}],"remove":[{"id":"4000000062001"}],"id":"4000000062001"}],"recurrence":{"frequency":"daily","interval":1,"end_after_occurrences":"10","set_to_previous_businessday":"false","next_recurrence_after_close":"true","trigger_type":"first_to_occur","date_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"scheduler_based":{"name":"Set Up CI/CD Pipeline for Staging Environment","schedule_datetime":"2024-12-16T09:00:00.000Z","repetative_type":"daily","time_span":1,"days_of_week":["1"],"months_of_year":["1"],"repeat_on_type":0,"repeat_on_value":"1","ends_after_type":"none","ends_after_value":"20","skip_type":"skip","mail_to_user":{"zpuid":["4000000002055"]},"duration_type":"days","no_of_duration":"2","field_name":"status","time":"22:00"},"retain_comments":"false","retain_subtasks":"false","retain_config":{"comments":false,"billing_type":false,"followers":false,"description":false,"subtasks":false,"tags":false,"attachments":false,"teams":false}},"reminder":{"reminder_criteria":"on","field_type":"start_date","custom_date":"2023-12-20","no_of_duration":"2","time":"22:00","duration_type":"days","emailtemplate_id":"4000000008003","reminder_notify_users":[{"type":"days","values":["4000000002055"]}]},"budget_info":{"rate_per_hour":50,"budget":"12345:00","threshold":"234:00","hourly_budget":"40:00","hourly_budget_threshold":"35:00","revenue_budget":5000,"cost_rate_per_hour":30},"<field_name>":"In Progress"}
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();
SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();
URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/projects/23806000097545166/tasks");
HttpUriRequest requestObj = new HttpPost(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");
HttpEntityEnclosingRequestBase requestBase = (HttpEntityEnclosingRequestBase) requestObj;
[...]
